// XBee_Packet_Parser.cpp : Defines the entry point for the console application.
//


#include "stdafx.h"
#include "XBeePackets_Parse.h"
#include "XBeePackets_file_output.h"
#include <fstream>
#include <iostream>

using namespace std;



int oldmain(int argc, _TCHAR* argv[])
{
	XBeeInPacket inPacket;
	PacketHandler packetHandler;

	//open "capture.txt"
	cout<<"Opening file 'capture.txt'..."<<endl;
	ifstream captureTxt;
	

	captureTxt.open("capture.txt",fstream::binary);

	if (captureTxt.fail()){
		cout<<"Error opening file, press 'Enter' to exit"<<endl;
		cin.get();
		return -1;
	}
	else {
		cout<<"Opened successfully, reading file..."<<endl;
	}
	while (captureTxt.good()){
		int successFlag;
		timerStart();
		successFlag=packetHandler.getPacket(captureTxt, inPacket);
		if (successFlag==0){
			printToFile(inPacket);
		}
		
	}
	captureTxt.close();
	closeOutput();
	cout<<"Summary:"<<endl;
	cout<<"Checksum Incorrect: "<<packetHandler.getNumCorrupt()<<endl;
	cout<<"Start Delimiter Wrong: "<<packetHandler.getNumDropped()<<endl;
	cout<<"Total Packets: "<<packetHandler.getNumTotalPackets()<<endl;

	ofstream summaryTxt;
	summaryTxt.open("summary.txt");
	summaryTxt<<"Summary:"<<endl;
	summaryTxt<<"Checksum Incorrect: "<<packetHandler.getNumCorrupt()<<endl;
	summaryTxt<<"Start Delimiter Wrong: "<<packetHandler.getNumDropped()<<endl;
	summaryTxt<<"Total Packets: "<<packetHandler.getNumTotalPackets()<<endl;
	summaryTxt.close();

	cin.get();
		
	return 0;
}

